#lang racket

#|

This file runs the test suites for smaller languages in the bigger reduction systems 
(the results should not change). Specifically, it runs the stlc tests in the barrier
calculus and the barrier tests in the contract-nu calculus.

|#


(require redex/reduction-semantics
         "stlc.rkt"
         "stlc-test.rkt"
         
         "nu.rkt"
         "nu-test.rkt"

         "contract-nu.rkt"
         "contract-nu-test.rkt"
         "preservation.rkt")

(stlc-red-test nu-red)

(parameterize ([current-tc (λ (x) (term (nu-tc mt ,x)))]
               [current-red nu-red]
               [current-same-ty (λ (x y) (term (same-ty ,x ,y)))])
  (stlc-preservation)
  (show-steps stlc-red))


;; cannot reuse the following tests because there are
;; no labels on the Λ or is terms. Perhaps adding labels should
;; work, tho, because there are no casts?

#|
(stlc-red-test contract-nu-red)
(nu-red-test contract-nu-red)

(parameterize ([current-tc (λ (x) (term (contract-nu-tc mt ,x)))]
               [current-red contract-nu-red]
               [current-same-ty (λ (x y) (term (same-ty ,x ,y)))])
  (stlc-preservation)
  (nu-preservation)
  (show-steps nu-red))
|#